namespace Bug {

class API_EXPORT Exception
  : virtual public std::exception
  , virtual public boost::exception
{
};

}                                                           // namespace Bug

namespace Bug { namespace System {
class API_EXPORT Exception : virtual public Bug::Exception
{
};
}}                                                          // namespace System, Bug

namespace Bug { namespace System {
class API_EXPORT Some
{
public:
    struct API_EXPORT Exception : virtual public Bug::Exception
    {
        struct Fault1;
        struct Fault2;
    };
};

struct API_EXPORT Some::Exception::Fault1
  : public Some::Exception
  , public Bug::System::Exception
{
};

struct API_EXPORT Some::Exception::Fault2
  : public Some::Exception
  , public Bug::Exception
{
};

}}                                                          // namespace System, Bug
